# Created by pyp2rpm-3.3.5
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif
%bcond_without tests

%global pypi_name drgn

%global _description %{expand:
drgn (pronounced "dragon") is a debugger with an emphasis on programmability.
drgn exposes the types and variables in a program for easy, expressive
scripting in Python.}

Name:           python-%{pypi_name}
Version:        0.0.30+153.g78ef790b
Release:        1.20250415170116969149.main.153.g78ef790b%{?dist}
Summary:        Programmable debugger

License:        LGPL-2.1-or-later
URL:            https://github.com/osandov/drgn
Source0:        drgn-0.0.30+153.g78ef790b.tar.gz

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools)
%if %{with docs}
BuildRequires:  sed
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-docs
%endif
%if %{with tests}
BuildRequires:  python3dist(pytest)
%endif
BuildRequires:  gcc-c++
BuildRequires:  make
BuildRequires:  bzip2-devel
BuildRequires:  elfutils-devel
BuildRequires:  libkdumpfile-devel
BuildRequires:  zlib-devel
BuildRequires:  xz-devel
# These are needed when building from git snapshots
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool

%description %{_description}

%package -n     %{pypi_name}
Summary:        %{summary}

%description -n %{pypi_name} %{_description}

%if %{with docs}
%package -n %{pypi_name}-doc
Summary:        %{pypi_name} documentation
BuildArch:      noarch
Requires:       python3-docs

%description -n %{pypi_name}-doc %{_description}

This package contains additional documentation for %{pypi_name}.
%endif

%prep
%autosetup -n drgn-0.0.30+153.g78ef790b -p1
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info
%if %{with docs}
# Use local intersphinx inventory
sed -r \
    -e 's|https://docs.python.org/3|%{_docdir}/python3-docs/html|' \
    -i docs/conf.py
%endif
# Ensure version is always set, even when building from git snapshots
if [ ! -f drgn/internal/version.py ]; then
  echo '__version__ = "%{version}"' > drgn/internal/version.py
fi

%build
# verbose build
V=1 %py3_build

%if %{with docs}
# generate html docs
PYTHONPATH=${PWD} sphinx-build-3 docs html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}
%endif

%install
%py3_install
mkdir -p %{buildroot}%{_datadir}/drgn
cp -PR contrib tools %{buildroot}%{_datadir}/drgn

%if %{with tests}
%check
%pytest
%endif

%files -n %{pypi_name}
%license COPYING
%license LICENSES
%doc README.rst
%{_bindir}/drgn
%{_datadir}/drgn
%{python3_sitearch}/_%{pypi_name}.pyi
%{python3_sitearch}/_%{pypi_name}.cpython*.so
%{python3_sitearch}/%{pypi_name}
%{python3_sitearch}/_%{pypi_name}_util
%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n %{pypi_name}-doc
%license COPYING
%license LICENSES
%doc html
%endif

%changelog
* Tue Apr 15 2025 Packit <hello@packit.dev> - 0.0.30+153.g78ef790b-1.20250415170116969149.main.153.g78ef790b
- CI: update to Ubuntu 22.04, drop Python 3.6 and 3.7 (Omar Sandoval)
- vmtest.kbuild: add patch to work around ppc64 build failure (Omar Sandoval)
- Update libkdumpfile in manylinux wheels to 0.5.5 (Omar Sandoval)
- libdrgn: optionally split up libdrgn and _drgn Python extension .so files again (Omar Sandoval)
- libdrgn: x86_64: fix restoring rbp for ORC_TYPE_REGS (Omar Sandoval)
- tests: fix socket ResourceWarning in debuginfod tests (Omar Sandoval)
- tests: don't shell out for CLI tests (Omar Sandoval)
- libdrgn: Makefile: add plugins.h to SOURCES (Omar Sandoval)
- Fix the URLs of Oracle Linux documentation (Stephen Brennan)
- docs: update User Guide (Omar Sandoval)
- docs: update Advanced Usage (Omar Sandoval)
- docs: add man page (Omar Sandoval)
- docs: split up table of contents into sections (Omar Sandoval)
- Drop "new" return from prog.*_module(create=True) (Omar Sandoval)
- docs: fix formatting of create_loaded_modules() docstring (Omar Sandoval)
- Add module lookups by name (Omar Sandoval)
- libdrgn: debug_info: index modules by name (Omar Sandoval)
- libdrgn: get rid of struct drgn_module_key (Omar Sandoval)
- libdrgn: hash_table: add delete_entry (Omar Sandoval)
- libdrgn: replace drgn_module_find() with kind-specific find functions (Omar Sandoval)
- libdrgn: linux_kernel: don't use drgn_module_find_or_create() (Omar Sandoval)
- vmtest.config: enable CONFIG_KPROBES for upcoming kmodify breakpoints (Omar Sandoval)
- Add 6.15 to supported kernels (Omar Sandoval)
- drgn.helpers.linux.kernfs: add kernfs_root() helper (Omar Sandoval)
- drgn.helpers.linux.kernfs: add kernfs_parent() and handle 6.15 (Omar Sandoval)
- drgn.helpers.linux.fs: handle DCACHE_MOUNTED value change in 6.15 (Omar Sandoval)
- Add NOT_IMPLEMENTED absence reason and use it for DWARF (Omar Sandoval)
- Add OPTIMIZED_OUT absence reason and use it for DWARF (Omar Sandoval)
- Add absence reason to absent objects (Omar Sandoval)
- CI: install pyroute2 < 0.9.1 for Python < 3.9. (Omar Sandoval)
- cli: include debuginfod support status in version banner (Omar Sandoval)
- libdrgn: linux_kernel: disable debuginfod except on Fedora (Omar Sandoval)
- README: clean up and update installation instructions for libdebuginfod (Omar Sandoval)
- drgn.helpers.experimental.kmodify: add wake_up_process() example to call_function() docstring (Omar Sandoval)
- cli: log missing main debug info as critical (Omar Sandoval)
- libdrgn: debug_info: simplify missing debug info error return in load_debug_info() (Omar Sandoval)
- libdrgn: debug_info: improve load_debug_info() warnings for kernel (Omar Sandoval)
- Add Program.create_loaded_modules() (Omar Sandoval)
- tests: expand CLI tests (Omar Sandoval)
- cli: handle !isatty(stdin) (Omar Sandoval)
- cli: rename args.script to args.args (Omar Sandoval)
- cli: set default program for -e (Omar Sandoval)
- cli: fix 'staticmethod' object is not callable for Python < 3.10 (Stephen Brennan)
- tests: add simple CLI smoke test (Stephen Brennan)
- cli: add -e option to exec() code directly (Stephen Brennan)
- cli: extract out default_globals() (Stephen Brennan)
- cli: clarify locations -> directories in help strings (Omar Sandoval)
- cli: allow enabling/disabling debug info finders with --{try,no}-symbols-by (Omar Sandoval)
- docs: emphasize that ExtraModule name and ID are both arbitrary (Omar Sandoval)
- docs: document details of bias calculation (Omar Sandoval)
- libdrgn: debug_info: don't set extra module bias if address range is empty (Omar Sandoval)
- Handle truncated pr_fname (Stephen Brennan)
- libdrgn: dwarf_info: skip DW_CFA_GNU_args_size (Omar Sandoval)
- libdrgn: stack_trace: allow unwinding anything with a pt_regs (Stephen Brennan)
- tests: test FaultError translation (Omar Sandoval)
- libdrgn: python: pass fault errors through (Stephen Brennan)
- libdrgn/python: modernize drgn_error_from_python() (Stephen Brennan)
- drgn.helpers.linux: add kthread helpers (Omar Sandoval)
- Use shell builtin instead of which (Septatrix)
- libdrgn: dwarf_info: index imported units (Omar Sandoval)
- libdrgn: dwarf_info: use //-style comments in enum drgn_dwarf_index_abbrev_insn (Omar Sandoval)
- libdrgn: dwarf_info: move drgn_dwarf_index_find_cu() code (Omar Sandoval)
- libdrgn: dwarf_info: parse specifications in second indexing pass (Omar Sandoval)
- libdrgn: dwarf_info: bounds check specifications while indexing (Omar Sandoval)
- libdrgn: dwarf_info: read units of supplementary debug files (Omar Sandoval)
- libdrgn: dwarf_info: don't index partial units (Omar Sandoval)
- libdrgn: dwarf_info: create separate CU lookup table (Omar Sandoval)
- libdrgn: dwarf_info: read all abbreviation tables before indexing CUs (Omar Sandoval)
- libdrgn: dwarf_info: update DWARF index in one OpenMP parallel region (Omar Sandoval)
- libdrgn: debug_info: check for supplementary debug file in drgn_module_find_dwarf_file() (Omar Sandoval)
- libdrgn: dwarf_info: resolve address of inline member functions (Omar Sandoval)
- Fix task_cpu() and stack traces for CentOS/RHEL 9 kernels (Omar Sandoval)
- tests: test invalid DW_AT_sibling handling (Omar Sandoval)
- tests: dwarfwriter: add compile_dwarf() function that returns labels (Omar Sandoval)
- tests: dwarfwriter: add optional label for top-level DIEs (Omar Sandoval)
- tests: test all DWARF reference forms (Omar Sandoval)
- tests: move .gnu_debug{,alt}link encoding to elfwriter (Omar Sandoval)
- tests: dwarfwriter: remove dwarf_sections() (Omar Sandoval)
- tests: don't add DWARF to ELF symbol test files (Omar Sandoval)
- tests: dwarfwriter: rename compile_dwarf() to create_dwarf_file() (Omar Sandoval)
- tests: handle PrimitiveType in assertIdentical() (Omar Sandoval)
- docs: update required Sphinx version to 7.3.7 (Omar Sandoval)
- docs: suggest usage of operator.index()/IntegerLike instead of Object.value_() (Omar Sandoval)
- vmtest.__main__: exit with non-zero status on failure (Omar Sandoval)
- libdrgn: rename drgn_object_slice() to drgn_object_fragment() (Omar Sandoval)
- tests: add test for unwinding through IRQ handler (Omar Sandoval)
- vmtest: use cortex-a76 CPU for AArch64 emulation (Omar Sandoval)
- Fix exception handling in for_each_child_dentry (Septatrix)
- dco-check: enforce that sign-off matches commit author (Omar Sandoval)
- Revert "vmtest.kbuild: add patch to fix 9p slab cache naming on Linux 6.12" (Omar Sandoval)
- vmtest.kbuild: add patch to work around missing build ID on aarch64:5.18.19-vmtest32.0alternative (Omar Sandoval)
- tests: linux_kernel: test built-in ORC unwinding (Stephen Brennan)
- orc_info: use a constant for size of the ORC version header (Stephen Brennan)
- orc_info: store biased pc_base (Stephen Brennan)
- orc_info: enable the use of built-in ORC (Stephen Brennan)
- module: add object (Stephen Brennan)
- libdrgn: python: add Module_prog (Stephen Brennan)
- orc_info: don't use ELF_Data when processing orc header (Stephen Brennan)
- tests: remove leftover debugging code in symbols test (Omar Sandoval)
- tests: don't run TC tests with old pyroute2 (Omar Sandoval)
- libdrgn: dwarf_info: fix DWARF index error handling (Omar Sandoval)
- tests: skip slow test_mtree_load_three_levels* tests under emulation (Omar Sandoval)
- libdrgn: dwarf_info: use uintptr_t for DIE addresses in DWARF index (Omar Sandoval)
- drgn.helpers.experimental.kmodify: sign-extend <32-bit arguments (Omar Sandoval)
- drgn.helpers.experimental.kmodify: apply conversions to literal arguments (Omar Sandoval)
- libdrgn: dwarf_info: add bias to DW_OP_addr in the middle of an expression (Omar Sandoval)
- README: exclude unsupported repositories from Repology badge (Omar Sandoval)
- docs: add video to blk-rq-qos crash tutorial (Omar Sandoval)
- docs: add a hands-on tutorial for a blk-rq-qos crash (Omar Sandoval)
- Add 6.14 to supported kernels (Omar Sandoval)
- Add plugin system (Omar Sandoval)
- libdrgn: replace blocking callbacks with hard-coded functions (Omar Sandoval)
- libdrgn: always make drgn_program available to Python (Omar Sandoval)
- libdrgn: combine libdrgn and _drgn Python extension into one .so (Omar Sandoval)
- libdrgn: linux_kernel: handle module section/note changes in Linux 6.14 (Omar Sandoval)
- Build manylinux wheels with debuginfod support (Omar Sandoval)
- Support searching for kernel modules without depmod metadata (Omar Sandoval)
- libdrgn: debug_info: clean up drgn_module_standard_files_state (Omar Sandoval)
- Add a debug info option for kernel directories (Omar Sandoval)
- Add debug info options for disabling search methods (Omar Sandoval)
- Add Program.find_standard_debug_info() (Omar Sandoval)
- Replace debug_info_path with debug_info_options (Omar Sandoval)
- libdrgn/python: factor path sequence argument parsing out of Program_load_debug_info() (Omar Sandoval)
- libdrgn: hash_table: add hash_table_for_each() (Omar Sandoval)
- libdrgn: debug_info: match vmlinux by version if build ID is not available (Omar Sandoval)
- libdrgn: add VECTOR and HASH_TABLE scope guards (Omar Sandoval)
- libdrgn/python: fix segfault on del prog.language and more (Omar Sandoval)
- libdrgn/python: remove dead misspelled ifdef block (Omar Sandoval)
- libdrgn: stack_trace: give hint when stack_trace(0) fails (Omar Sandoval)
- contrib/stack_trace_call_fault.py: support AArch64 (Omar Sandoval)
- libdrgn: aarch64: implement bad call unwinding (Omar Sandoval)
- libdrgn: register_state: add drgn_register_state_unset_has_register() (Omar Sandoval)
- libdrgn: stack_trace: make bad call unwinding an architecture callback (Omar Sandoval)
- libdrgn/python: unexport set_drgn_error() (Omar Sandoval)
- docs: use envvar directive for environment variables (Omar Sandoval)
- Make StackFrame.name fall back to symbol/PC and add StackFrame.function_name (Omar Sandoval)
- libdrgn: kdump: prepare for incompatible changes in libkdumpfile-0.5.5 (Petr Tesarik)
- libdrgn: kdump: simplify getting the PRSTATUS attributes (Petr Tesarik)
- Update Ubuntu instructions (Michel Lind)
- tests: drop leftover debugging print (Omar Sandoval)
- libdrgn: don't bother getting program language to initialize object (Omar Sandoval)
- tests: don't clobber file in use by libelf (Omar Sandoval)
- Introduce module and debug info finder APIs (Omar Sandoval)
- libdrgn: add API for choosing file to write progress bars to (Omar Sandoval)
- libdrgn: debug_info: add debuginfod client scaffolding (Omar Sandoval)
- libdrgn: linux_kernel: move depmod index code (Omar Sandoval)
- libdrgn: linux_kernel: parse build ID in VMCOREINFO (Omar Sandoval)
- libdrgn: binary_search_tree: add delete_entry (Omar Sandoval)
- libdrgn: add functions for deserializing 64- or 32-bit structures (Omar Sandoval)
- libdrgn: add hexadecimal encoding/decoding functions (Omar Sandoval)
- libdrgn: add CRC-32 implementation (Omar Sandoval)
- libdrgn: elf_notes: add helper function for looking up notes (Omar Sandoval)
- libdrgn: enable -Wformat-security (Omar Sandoval)
